#include <Blackfin_definitions.h>
#include <functions.h>

extern int DummyBuffer;
extern int SPICount;
extern int TransferStatus;
extern int InterruptCause;
extern int TimerInterruptCause;
extern int ClockDone;
extern int PPIDone;
extern int ReadyForInput;
int tempvar;
int PPIDMACount = 0;


EX_INTERRUPT_HANDLER (MMCIsr)
{
    PPIDMACount++;
    switch(InterruptCause)
    {
    	case 1: *pDMA0_IRQ_STATUS |= 0x0001;
    			PPIDone = 0;  
    			break;
    	case 2: *pDMA0_IRQ_STATUS |= 0x0001;
    			ssync();
    			*pDMA0_CONFIG = 0x0;  
    			*pTIMER_DISABLE = TIMDIS6;
		    	while(*pTIMER_STATUS & TRUN6);
		    	PPIDone = 0; 
    			break;
    			
    	case 3: *pDMA0_IRQ_STATUS |= 0x0001;
    			ssync();
    			DisablePPIReceive();   
    			*pTIMER_DISABLE = TIMDIS6 | TIMDIS7;
		    	while(*pTIMER_STATUS & (TRUN6|TRUN7));
    			PPIDone = 0; 
    			break;
    			
    	case 4: *pDMA0_IRQ_STATUS |= 0x0001;
    			ssync();
    			DisablePPIReceive();   
    			*pTIMER_DISABLE = TIMDIS6;
		    	while(*pTIMER_STATUS & TRUN6);
    			PPIDone = 0; 
    			break;
    			
    	default:break;
    }
}
EX_INTERRUPT_HANDLER (TimerISR)
{ 
    switch(TimerInterruptCause)
    {
    case 1: //only SD/MMC clock running
		    ClockDone = 0; 
		    *pTCNTL = 0;
		    break;
	
	case 2: //only BF-PPI clock running
			ClockDone = 0;
			*pTCNTL = 0;
			*pTIMER_DISABLE = TIMDIS6;
			while(*pTIMER_STATUS & TRUN6);
			break;	   
	
	case 3: //both SD/MMC and BF-PPI timers running
			ClockDone = 0;			
			*pTCNTL = 0;
		    *pTIMER_DISABLE = TIMDIS6;
		    while(*pTIMER_STATUS & TRUN6);
		    if(InterruptCause == 1)
		    {
		        	DisablePPITransmit();
		    }
		    break;
	
	default: break;
    }
}

EX_INTERRUPT_HANDLER (PFIsr)
{
    *pPORTFIO_CLEAR = PF8;
    *pTIMER_DISABLE = TIMDIS7;
	while(*pTIMER_STATUS & TRUN7);
    ReadyForInput = 1;
    *pSIC_IMASK &= ~IRQ_PFA_PORTF;
    tempvar = *pPORTFIO_CLEAR;
    *pPORTFIO_INEN &= ~PF8;
}

EX_INTERRUPT_HANDLER (PFDataIsr)
{
    *pPORTFIO_CLEAR = PF9;
    *pTIMER_DISABLE = TIMDIS7;
	while(*pTIMER_STATUS & TRUN7);
    ReadyForInput = 1;
    *pSIC_IMASK &= ~IRQ_PFB_PORTF;
    tempvar = *pPORTFIO_CLEAR;
    *pPORTFIO_INEN &= ~PF9; 
}
